<template>
  <div>
    <!-- start: label -->
    <label class="text-sm" :for="id">{{ label }}</label>
    <!-- end: label -->

    <!-- start: input part -->
    <div class="flex relative items-center mt-1 mb-2 w-full">
      <input
        class="py-2 px-4 rounded-sm
          bg-data-grey focus:outline-none w-full border"
        :class="inputBorder"
        :type="inputType"
        :placeholder="placeholder"
        :value="value"
        @input="$emit('input', $event.target.value)"
        :id="id"
      />
      <button
        tabindex="-1"
        type="button"
        v-if="passwordToggle"
        class="absolute bg-grey-700 px-2 py-3 right-0 mr-2 focus:outline-none"
        @click="showPassword = !showPassword"
      >
        <img
          :src="showPassword ? passwordHideIcon : passwordShowIcon"
        />
      </button>
    </div>
    <!-- end: input part -->

    <!-- start: helper text -->
    <div class="text-sm" v-if="error || helper">
      <div class="text-red-500" v-if="error">{{ error }}</div>
      <div v-else-if="helper">{{ helper }}</div>
    </div>
    <!-- end: helper text -->
  </div>
</template>

<script>
import PasswordHideIcon from '~/assets/icons/password-hide.svg';
import PasswordShowIcon from '~/assets/icons/password-show.svg';

export default {
  props: {
    type: {
      type: String,
      default: 'text',
    },
    passwordToggle: {
      type: Boolean,
      default: false,
    },
    helper: {
      type: String,
      default: '',
    },
    error: {
      type: String,
      default: '',
    },
    placeholder: {
      type: String,
      default: '',
    },
    label: {
      type: String,
      required: true,
    },
    id: {
      type: String,
      required: true,
    },
    value: {
      type: String,
      required: true,
    },
  },

  data: () => ({
    showPassword: false,
    passwordHideIcon: PasswordHideIcon,
    passwordShowIcon: PasswordShowIcon,
  }),

  created: function() {
    if (this.passwordToggle && this.type !== 'password') {
      throw new Error('Password toggle only works on \'password\' type');
    }
  },

  computed: {
    inputType: function() {
      if (!this.passwordToggle) {
        return this.type;
      }

      return this.showPassword ? 'text' : this.type;
    },

    inputBorder: function() {
      if (this.error) {
        return 'border-data-red';
      }

      return 'border-transparent focus:border-data-blue';
    },
  },
};
</script>

<style lang="postcss" scoped>
</style>
